
class segmenttree:

    def __init__(self, n, heap):
        self.edges = n-1
        self.s = 1
        while self.s < self.edges:
            self.s *= 2

        # segtree with tuples (mini, update)
        self.segtree = [[0, 0] for _ in range(0, 2*self.s)]

        for i in range(0, self.edges):
            self.segtree[self.s+i][1] = heap[i+2] - heap[(i+2)//2]
            self.segtree[self.s+i][0] = self.segtree[self.s+i][1]

        for i in range(self.s - 1, 0, -1):
            self.segtree[i][0] = \
                min(self.segtree[2*i][0], self.segtree[2*i+1][0]) + self.segtree[i][1]


    def isHeap(self):
        if self.segtree[1][0] >= 0: print("TAK")
        else: print("NIE")


    def updateSegment(self, v, l, r, x, y, z):
        if x > y or r < x or y < l:
            return

        if x <= l and r <= y:
            self.segtree[v][1] += z
            self.segtree[v][0] += z
            return

        self.updateSegment(2*v, l, (l+r)//2, x, y, z)
        self.updateSegment(2*v+1, (l+r)//2+1, r, x, y, z)
        self.segtree[v][0] = \
                min(self.segtree[2*v][0], self.segtree[2*v+1][0]) + self.segtree[v][1]


    def update(self, x, y, z):
        self.updateSegment(1, 0, self.s-1, max(x-2, 0), min(y-2, self.edges-1), z)
        self.updateSegment(1, 0, self.s-1, max(2*x-2, 0), min(2*y-1, self.edges-1), -z)


def main():
    n = int(input())
    heap = [0 for _ in range(0, n+1)]
    for i, val in enumerate(input().split(" "), 1):
        heap[i] = int(val)

    tree = segmenttree(n, heap)

    tree.isHeap()
    q = int(input())

    while q > 0:
        x, y, z = [int(i) for i in input().split(" ")]

        tree.update(x, y, z)
        tree.isHeap()

        q -= 1


main()
